-------------------------------------------------------------------------------
--
-- Title       : TutorVHDL
-- Design      : TutorVHDL
-- Author      : J.Kasperek & P.J.Rajda
-- Company     : AGH Krakw
--
-------------------------------------------------------------------------------
--
-- Description : 
-- Synchronous 3bits binary up counter with synchronous reset
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_unsigned.all;


entity TutorVHDL is
	port(
		CLR : in STD_LOGIC;			-- clear signal 
		CLK : in STD_LOGIC;			-- clock 
		Q : out STD_LOGIC_VECTOR(2 downto 0)	-- outputs
		);
end TutorVHDL;


architecture TutorVHDL of TutorVHDL is	 
begin
	process (CLK)
		-- internal variable Q_INT
		variable Q_INT: STD_LOGIC_VECTOR(2 downto 0);
	begin
		if CLK'event and CLK='1' then
			if CLR='1' then
				Q_INT := "000";
			else	
				Q_INT := Q_INT+1;
			end if;
		end if;	
		Q <= Q_INT;
	end process;
	
end TutorVHDL;
